Attribute VB_Name = "mTools"
Option Explicit

'Converts an item identifier list to a file system path.
Private Declare Function SHGetPathFromIDList Lib "shell32" _
   Alias "SHGetPathFromIDListA" _
  (ByVal pidl As Long, _
   ByVal pszPath As String) As Long

Private Declare Function SHGetSpecialFolderLocation Lib "shell32" _
   (ByVal hwndOwner As Long, _
    ByVal nFolder As Long, _
    pidl As Long) As Long

Private Declare Sub CoTaskMemFree Lib "ole32" _
   (ByVal pv As Long)

Private Const MAX_PATH As Long = 260
Private Const S_OK = 0

'Credits to Sherlog <sherlog@t-online.de> for finding out the algorithm
'Rewritten from C
Public Function FLCDecode(strCharFilename As String, strOut As String) As Boolean

     Dim Gene(0 To 3) As Byte
     Gene(0) = &H47 'G
     Gene(1) = &H65 'e
     Gene(2) = &H6E 'n
     Gene(3) = &H65 'e
     Dim out() As Byte
     Dim playerBytes() As Byte
     Dim fileLength As Long
     Dim iFileNo As Integer
     iFileNo = FreeFile()
     Open strCharFilename For Binary As #iFileNo
     Dim strFile As String
     strFile = Input$(4, iFileNo)
     If strFile <> "FLS1" Then 'Charfile not encoded
        strOut = strFile & Input$(LOF(iFileNo) - 4, iFileNo)
        Close #iFileNo
        FLCDecode = False
        Exit Function
     End If
     fileLength = LOF(iFileNo)
     ReDim playerBytes(0 To fileLength - 1)
     ReDim out(0 To (fileLength - 5) * 2 + 1)
     Get #iFileNo, 1, playerBytes
     Close #iFileNo
     
     Dim i As Long, l As Long
     i = 0
     l = fileLength - 4
    
     Do While i < l
       Dim c As Byte, k As Byte, r As Byte
       c = playerBytes(i + 4)
       k = (Gene(i Mod 4) + i) Mod 256
    
       r = c Xor (k Or &H80)
       
       out(i * 2) = r
       i = i + 1
     Loop
     
     strOut = out
 
    FLCDecode = True
End Function

Public Function FLCEncode(strIn As String, strCharFilename As String)

     Dim Gene(0 To 3) As Byte
     Gene(0) = &H47 'G
     Gene(1) = &H65 'e
     Gene(2) = &H6E 'n
     Gene(3) = &H65 'e
     Dim byteIn() As Byte
     byteIn = strIn
     Dim iFileNo As Integer
     iFileNo = FreeFile()
     Open strCharFilename For Binary Access Write As #iFileNo
     Put #iFileNo, , "FLS1"
     
     Dim i As Long, l As Long
     i = 0
     l = Len(strIn)
    
     Do While i < l
       Dim c As Byte, k As Byte, r As Byte
       c = byteIn(i * 2)
       k = (Gene(i Mod 4) + i) Mod 256
       r = c Xor (k Or &H80)
       
       Put #iFileNo, , r
       
       i = i + 1
     Loop
     Close #iFileNo
 
End Function

Public Function getSubFolders(folderPath As String) As Variant
    Dim getFolders As Variant
    getFolders = Array()
    
    Dim fs, f, f1, sf
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set f = fs.GetFolder(folderPath)
    Set sf = f.subFolders
    For Each f1 In sf
        ReDim Preserve getFolders(0 To UBound(getFolders) + 1)
        getFolders(UBound(getFolders)) = folderPath & "\" & f1.Name
        addSubFolders folderPath & "\" & f1.Name, getFolders
    Next
    Set fs = Nothing
    Set f = Nothing
    Set sf = Nothing

    DoEvents
    getSubFolders = getFolders
End Function

'Recursively called function, adds subfolders of folderPath to folderArray
Private Function addSubFolders(folderPath As String, ByRef folderArray As Variant)
    Dim fs, f, f1, sf
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set f = fs.GetFolder(folderPath)
    Set sf = f.subFolders
    For Each f1 In sf
        ReDim Preserve folderArray(0 To UBound(folderArray) + 1)
        folderArray(UBound(folderArray)) = folderPath & "\" & f1.Name
        addSubFolders folderPath & "\" & f1.Name, folderArray
    Next
    Set fs = Nothing
    Set f = Nothing
    Set sf = Nothing
    DoEvents
End Function

Public Sub addLog(str As String)
    frmMain.txtLog.Text = frmMain.txtLog.Text & vbCrLf & str
End Sub

Public Sub replaceLog(str As String, iTakeAway As Long)
    frmMain.txtLog.Text = Left$(frmMain.txtLog.Text, Len(frmMain.txtLog.Text) - iTakeAway) & str
End Sub

Public Sub writeFile(strText As String, strFilename As String)
    Dim iFileNo As Integer
    iFileNo = FreeFile()
    Open strFilename For Output As #iFileNo
    Print #iFileNo, strText;
    Close #iFileNo
End Sub

Public Function GetSpecialFolderLocation(CSIDL As Long) As String

   Dim sPath As String
   Dim pidl As Long
   
  'fill the idl structure with the specified folder item
   If SHGetSpecialFolderLocation(frmMain.hWnd, CSIDL, pidl) = S_OK Then
     
     'if the pidl is returned, initialize
     'and get the path from the id list
      sPath = Space$(MAX_PATH)
      
      If SHGetPathFromIDList(ByVal pidl, ByVal sPath) Then

        'return the path
         GetSpecialFolderLocation = Left(sPath, InStr(sPath, Chr$(0)) - 1)
         
      End If
    
     'free the pidl
      Call CoTaskMemFree(pidl)

    End If
   
End Function

